this is probably the best visual explanation i've seen thus far. This is really excellent, the ability to break it down with such simplicity. Subscribed.
Man I dont how you get answers like this! Been doing the leetcode 30 day challenge with you. Love your way of thinking and understanding! Would love for you to do a video of when to use different approaches like backtracking, sliding window etc!
So underrated but such a useful video with very clear explanation. I was able to solve a related problem after watching the video halfway. Thank you so much.
You are doing awesome job, i have refered other video where people just memorize and repeat, you understand and explain things. Very helpful. Keep doing the good work.
this was so simple, but finding a rectangle was so complicated, we literally converted that to a histogram for each row and calculated that. wish there was a simple dp like this for that problem.
If i get this in an interview I'm walking out...Great explanation though, 0% chance you could solve this without already knowing the solution or something similar in a 30 min interview. And i'm solid at DP
1st row and 1st column is not necessary in dynamic 2d array. We can take a 2d dp array of same size as input and fill it's 1st row and 1 column separately by the elements same as present in input array and then we can follow the same approach as mentioned in the video to fill other rows and columns.
Practice, practice, sis... Train your sense of determining the problem is solved by applying DP (1 dimension or 2 dimensions, or even more), and then follow some formal steps: what is a sub problem, what is recurrent formula, what are the initial values, which way to fill the table where is the answer in the table.
@@Siva-lx9dw Solve more questions and explore different solutions to a problem. Before solving a problem, you can try to come up with a solution (especially when your interview is far away). Also, once you see a solution to a problem, don't just move on. Analyze why the solution works the way it, and compare it to how you were approaching the problem in the first place (even though you never arrived at the solution). Analyze the data structures used, and question why that specific data structure was used, and if you could solve it with an alternate data structure. In summary, analyze solutions, and ask your self why it works the way it works. Try to code the implementation (this is also one way to learn deeply why a solution works).
great job; but u could have done it with just m*n dp instead of m+1*n+1 dp by hard coding top row and left column as default values of original matrix avoiding confusion
Hi, @TECH DOSE Were you able to make this video? Sorry for pestering you, but it would be really helpful if someone could provide a link to this if he has made it.
Crisp and clear explanation. Thanks ! All of your videos are of great help. If you would like I can contribute to Python solutions of your videos. Github repo will be a good idea.
@@crimsoncad3230 I just checked if encountered 1, then dfs from that location and incresed the count diagonally and check whether all are 1s in that square here is my code bool isSafe(int i, int j, vector grid){ if(i= grid.size() or j= grid[i].size()) return 0; return 1; } int dfs(int i, int j, int count, vector grid){ //check diagonal right is 1 or not if(!isSafe(i+1, j+1, grid)){ return count*count; } //then check for max size of square formed for(int k=0; k ans ? curr : ans; } } } return ans; }
Thank you. your video helped me solved the problem. But I feel I am lacking so much more. Can anyone please tell me how do I improve dynamic programming problems? Can you recommend any resources? These DP problems are lowering my confidence day by day.
@@techdose4u Thanks for kind words :) I started leetcode with "30 days challenge" only. out of 26 problems I was able to solve only 16. Remaining times, I had to look for explanations and understand and submit. So I was looking for help if I need to prepare and understand something, before answering leetcode solutions. Bytheway your explanation is so crisp than many other foreigner leetcode videos. They directly jump to code.
I don't find meaning in explaining code. The important thing is how you thought about that process. Practice is always good. 16 is better than 15. You did well. You will only improve from here on. So don't stop. Keep practicing :)
Now I knew when I saw the question that it's got something to do with DP. But I froze at the thought of coding a DP solution. What do you recommend to practice in/read for getting more confident?
Hi Sir, Your explanation is crystal clear. 😊 Can you please tell me the name of Recording application? I tried to Google but didn't find any recorder as good as this. Reply reply 😊
I had some hard time fully understanding the DP approach so I managed to come up with another way to solve it in O(Nrows * Ncols) time and O(Ncols) space. The idea is to reuse what we learned with largest rectangle of 1s in a matrix. Once we get a histogram, just look for a square with side equal to (1 + current maximum side). I may make a video of it on my channel
``` class Solution: def maximalSquare(self, matrix: List[List[str]]) -> int: rows, cols = len(matrix), len(matrix[0]) #--------------------------------------------------------------------------------------------------------------- # Time complexity - O(rows*cols) def solve1(): dp = [0] * (cols+1) area, prev = 0, 0 for r in range(1, rows+1): for c in range(1, cols+1): temp = dp[c] if matrix[r-1][c-1] == '1': dp[c] = 1 + min(prev, dp[c-1], dp[c]) area = max(area, dp[c]) else: dp[c] = 0 prev = temp return area**2 #--------------------------------------------------------------------------------------------------------------- # Time complexity (TLE without cache) - O((rows*cols)*(rows*cols)) @lru_cache(None) def dfs(r, c): if r >= rows or c >= cols or matrix[r][c] == '0': return 0 return 1 + min(dfs(r+1, c), dfs(r, c+1), dfs(r+1, c+1)) def solve2(): area = 0 for r in range(rows): for c in range(cols): area = max(area, dfs(r, c)) return area**2 #--------------------------------------------------------------------------------------------------------------- # Time complexity (ACCEPTED) - O((rows*cols)*(rows*cols)) def solve3(): area = 0 for r in range(rows): for c in range(cols): if matrix[r][c] == '1': curr = 1 flag = True while r + curr < rows and c + curr < cols and flag: for c_ in range(c, c+curr+1): if matrix[r+curr][c_] == '0': flag = False break for r_ in range(r, r+curr+1): if matrix[r_][c+curr] == '0': flag = False break if flag: curr += 1 area = max(area, curr) return area**2 ```
Pardon? I think you want to know what to learn. Keep practicing dp questions. As you practice, keep searching about each and reason for a step. In this way, you will learn dp.
Well, a rectangle can be thought of as combination of 2 or more squares in the matrix. So we have to find continuous ccurrences of 2s or 3s or any higher number in a row of this DP matrix. We may take a counter "c" initialised to the first occurrence of a number >=2 in each row. And then increment it by one as an when we find more continuous occurrences of that number in the same row. We compute the area of a possible rectangle in each row traversal and store this value in a max variable. The area can be calculated as: counter × largest
@@techdose4u I found out that for a problem if I watched your video, I can remember the solution for a Longgg time, if watch other's video I will forget the solution the next day. 😂
The idea is to check if there are occurrences of 0s in any of the past adjacent cells. Say you are currently at i = 3, j = 4 of the above example. If you take min of past adjacent cells, and it comes out as 0 then it means that a 2×2 square matrix CANNOT be formed. If you have min as 1 that means 3×3 matrix of 1s cannot be formed, here only a 2×2 is possible.
"im not sure if you can understand this" and "I hope you are understanding this" haha, love these two quotes haha lol
😅
this is probably the best visual explanation i've seen thus far. This is really excellent, the ability to break it down with such simplicity. Subscribed.
Thanks :)
Unbelievable 😌😌
Subscribed :)
Man I dont how you get answers like this! Been doing the leetcode 30 day challenge with you. Love your way of thinking and understanding! Would love for you to do a video of when to use different approaches like backtracking, sliding window etc!
I will do it soon bro....
amazing explanation, thank you! I love how you walk us through your thought process and assume that we don't know what you are talking about.
Yep I can't assume everyone to understand me completely 😅
The way u explain with examples and all sorts of intutions, helps a lot to understand complex algorithms and codes. Yhank you so much
Thanks bro :)
So underrated but such a useful video with very clear explanation. I was able to solve a related problem after watching the video halfway. Thank you so much.
Welcome :)
Thank you this is the easiest explanation I've found so far on the internet for this problem.
I have seen your previous videos too, you are one of the best when it comes to explaining solutions!
Thanks :)
This channel deserves more subscription. You explained very well . Thanks a lot!
Welcome :)
You are doing awesome job, i have refered other video where people just memorize and repeat, you understand and explain things. Very helpful. Keep doing the good work.
Thanks bro :)
You've been a great help in my learning of DSA. Thank you.
Welcome :)
As always...the best explanation available on youtube.....Thanks a lot surya...
TechDose, helping us learn DS and get jobs since 2019:)
Even beginners can understand DP , the way you explain is soo good.
Thanks
The Best Explanation of DP. Made it look so easy at the end !!
Thanks :)
Tech dose has become my daily dose
❤️
Marvelous solution! I love DP programming and your thought process. Thank you.
Welcome :)
Your videos have been helping me out a lot. Just wanted to say thanks
Welcome :)
this was so simple, but finding a rectangle was so complicated, we literally converted that to a histogram for each row and calculated that. wish there was a simple dp like this for that problem.
I was super confused how to solve the problem. You gave me a nice hint. Thanks.
Welcome
Best explanation of the problem. Hat's OFF......
Thanks
No words to appreciate ur xplaination.
Thanks :)
Clear Explanation ! 👌👨💻
Thanks :)
You make the best explanation videos for leetcode, hands down. Please make a video for #31 Next Permutation
Thanks. I will try to make it soon :)
Nice Explanation you are doing great job.................:)
You simplified the problem, very well explained. thanks!!
Welcome :)
Awesome thanks! By far a detailed explanation. Subscribed for more.
Welcome 😄
Thanking you bro ..it is very much helpful to me in the views of placement ..keep posting bro..😍😍😍😍
Sure will keep posting :)
Ye pyaar nhi toh aur kya hai !
Amazing video bro 👌
Thanks :)
Such a great programmer and the way of explanation is very nice we want more videos like this. sir try to make videos on recursion.
If i get this in an interview I'm walking out...Great explanation though, 0% chance you could solve this without already knowing the solution or something similar in a 30 min interview. And i'm solid at DP
1st row and 1st column is not necessary in dynamic 2d array. We can take a 2d dp array of same size as input and fill it's 1st row and 1 column separately by the elements same as present in input array and then we can follow the same approach as mentioned in the video to fill other rows and columns.
Love the explanation man !!
This type of approaches are far beyond our thought. How to proceed for this kinda questions?
Practice, practice, sis... Train your sense of determining the problem is solved by applying DP (1 dimension or 2 dimensions, or even more), and then follow some formal steps: what is a sub problem, what is recurrent formula, what are the initial values, which way to fill the table where is the answer in the table.
You will need a lot of practice to identify solution for these questions :)
@@techdose4u how to practice??
@@Siva-lx9dw Solve more questions and explore different solutions to a problem.
Before solving a problem, you can try to come up with a solution (especially when your interview is far away).
Also, once you see a solution to a problem, don't just move on. Analyze why the solution works the way it, and compare it to how you were approaching the problem in the first place (even though you never arrived at the solution).
Analyze the data structures used, and question why that specific data structure was used, and if you could solve it with an alternate data structure.
In summary, analyze solutions, and ask your self why it works the way it works. Try to code the implementation (this is also one way to learn deeply why a solution works).
great job;
but u could have done it with just m*n dp instead of m+1*n+1 dp by hard coding top row and left column as default values of original matrix avoiding confusion
Good Problem hard to think !!
Sure is :)
Thanks for help with this question, your explainations are really good
Thanks 😊
Nice explaination ...
Thanks
Hi TechDose, Congratulations on making such a beautiful video. You always succeed in making a deeper dive into the concept behind a solution.
Thanks :)
Awesome explanation.
I don't know how can anyone dislike it.
Thanks :)
Thankyou for such an amazing video!!
Awesome explain bror 👍👍
Nice explanation sir...you are doing a great job
Thanks
Sir can u tell more problems on dynamic programming concepts bcz so many placement questions asked on this basis
I will make a separate video on common patterns in dynamic programming questions. This will help you figure out the approach more in depth.
@@techdose4u Thanks! waiting for that video!
Hi, @TECH DOSE Were you able to make this video? Sorry for pestering you, but it would be really helpful if someone could provide a link to this if he has made it.
Really good explanation!! Thanks a lot!
Very good explanation. Thank you!
Welcome :)
wowwwww what an explanation!!!!!!!!!
Thanks ☺️
Very well explained. Thanks!!
Welcome
Best explanation 🔥
What a great explanation!!
thanks a lot for explaning such a hard problem in a easy way:)
Very nice explanation!!! Thank you!!
Thanks bro :)
Crisp and clear explanation. Thanks !
All of your videos are of great help. If you would like I can contribute to Python solutions of your videos. Github repo will be a good idea.
Nice .....I will create one....
Thank you so much, nice explanation
Great explanation
Thanks
GOD Level explanation
very good and detailed solution, thanks
Thanks
Lit🔥🔥 great video!
Thanks buddy :)
best explanation... thankyou
Welcome
Clean and clear explanation!
Thanks :)
I tried solving this problem using DFS and got TLE on last 3 test cases on LEETCODE as you said, but got accepted in GEEKSFORGEEKS 😜
😅
How did you solve using DFS???
@@crimsoncad3230 I just checked if encountered 1, then dfs from that location and incresed the count diagonally and check whether all are 1s in that square
here is my code
bool isSafe(int i, int j, vector grid){
if(i= grid.size() or j= grid[i].size())
return 0;
return 1;
}
int dfs(int i, int j, int count, vector grid){
//check diagonal right is 1 or not
if(!isSafe(i+1, j+1, grid)){
return count*count;
}
//then check for max size of square formed
for(int k=0; k ans ? curr : ans;
}
}
}
return ans;
}
should have memoized then
good explanation!!!
Thanks
Hi, I don't think we needed a dp matrix of size [n+1]*[n+1]. I think dp[n][n] would have worked. BTW love your videos :)
Take whatever works :)
Nice explain, thanks!
Welcome :)
very helpful video...
🤣
@@techdose4u 😂😂
hi , please could you tell me how to find the indexes where the square matrix begins ?
Thank you. your video helped me solved the problem. But I feel I am lacking so much more. Can anyone please tell me how do I improve dynamic programming problems? Can you recommend any resources? These DP problems are lowering my confidence day by day.
Don't be down. It's just a matter a time when you pick them. DP is always tricky 😅
@@techdose4u Thanks for kind words :) I started leetcode with "30 days challenge" only. out of 26 problems I was able to solve only 16. Remaining times, I had to look for explanations and understand and submit. So I was looking for help if I need to prepare and understand something, before answering leetcode solutions.
Bytheway your explanation is so crisp than many other foreigner leetcode videos. They directly jump to code.
I don't find meaning in explaining code. The important thing is how you thought about that process. Practice is always good. 16 is better than 15. You did well. You will only improve from here on. So don't stop. Keep practicing :)
can u explain why we take min from three directions??
Amazinggg sir 🙏🏻
Now I knew when I saw the question that it's got something to do with DP. But I froze at the thought of coding a DP solution. What do you recommend to practice in/read for getting more confident?
Both reading and practice will help. But the imp thing is to notice dp patterns, where to use and where not to. Observing is important.
Thank you sir 😊
Welcome :)
Great explanation brother proud to be an indian:)
i also solved this question by dp, it seems easy for me...still i watch your all videos to get better understanding 😄😄
Nice :)
great diagrams!
Thanks
Hi Sir,
Your explanation is crystal clear. 😊
Can you please tell me the name of Recording application?
I tried to Google but didn't find any recorder as good as this.
Reply reply 😊
Camtasia
very well explained!
Thanks
Amzing Sir.
well explained, thank you!
Welcome 🤗
dp is very beautiful
:)
so talented bruhh
Why we just checked dp [i-1][j-1] == 1 and not other two cells in if condition?
awesome bro!
Thanks
please do provide lnks for JAVA solutions if possible, you are doing great job Thanks
I had some hard time fully understanding the DP approach so I managed to come up with another way to solve it in O(Nrows * Ncols) time and O(Ncols) space. The idea is to reuse what we learned with largest rectangle of 1s in a matrix. Once we get a histogram, just look for a square with side equal to (1 + current maximum side). I may make a video of it on my channel
```
class Solution:
def maximalSquare(self, matrix: List[List[str]]) -> int:
rows, cols = len(matrix), len(matrix[0])
#---------------------------------------------------------------------------------------------------------------
# Time complexity - O(rows*cols)
def solve1():
dp = [0] * (cols+1)
area, prev = 0, 0
for r in range(1, rows+1):
for c in range(1, cols+1):
temp = dp[c]
if matrix[r-1][c-1] == '1':
dp[c] = 1 + min(prev, dp[c-1], dp[c])
area = max(area, dp[c])
else:
dp[c] = 0
prev = temp
return area**2
#---------------------------------------------------------------------------------------------------------------
# Time complexity (TLE without cache) - O((rows*cols)*(rows*cols))
@lru_cache(None)
def dfs(r, c):
if r >= rows or c >= cols or matrix[r][c] == '0':
return 0
return 1 + min(dfs(r+1, c), dfs(r, c+1), dfs(r+1, c+1))
def solve2():
area = 0
for r in range(rows):
for c in range(cols):
area = max(area, dfs(r, c))
return area**2
#---------------------------------------------------------------------------------------------------------------
# Time complexity (ACCEPTED) - O((rows*cols)*(rows*cols))
def solve3():
area = 0
for r in range(rows):
for c in range(cols):
if matrix[r][c] == '1':
curr = 1
flag = True
while r + curr < rows and c + curr < cols and flag:
for c_ in range(c, c+curr+1):
if matrix[r+curr][c_] == '0':
flag = False
break
for r_ in range(r, r+curr+1):
if matrix[r_][c+curr] == '0':
flag = False
break
if flag:
curr += 1
area = max(area, curr)
return area**2
```
👍🏼
Which would you suggest to learn dp?
Pardon? I think you want to know what to learn. Keep practicing dp questions. As you practice, keep searching about each and reason for a step. In this way, you will learn dp.
u r amazing.....thnku
Nice explanation 🙂
Thanks :)
Mind blowing approch
Thanks :)
what if we had to find rectangle instead of square??
Well, a rectangle can be thought of as combination of 2 or more squares in the matrix. So we have to find continuous ccurrences of 2s or 3s or any higher number in a row of this DP matrix.
We may take a counter "c" initialised to the first occurrence of a number >=2 in each row. And then increment it by one as an when we find more continuous occurrences of that number in the same row. We compute the area of a possible rectangle in each row traversal and store this value in a max variable. The area can be calculated as: counter × largest
Wow, thank you so much Sir ! I can understand it lol..
Welcome :)
@@techdose4u I found out that for a problem if I watched your video, I can remember the solution for a Longgg time, if watch other's video I will forget the solution the next day. 😂
@@yitingg7942 keep watching our videos ❤️
Sir how to do recursiveky
Hi , Can someone explain in first way how he is using dfs??
Thanks sir :-)
Welcome
Please sir, make a video on problem Game of two stacks of hackerrank
I have added this problem in my already long todo list. Will make it as soon as I get time for sure.
@@techdose4u Thank you sir
Why are you checking dp [i-1][j-1] == 1 in if condition ??
Diagonal adjacent cell is being checked here
Amazing
Awesome
I got this question on Amazon sde internship interview. Was not able to answer
🤔
@@techdose4u I appreciate what you have been doing for us. Please keep up this amazing job.
excellent.
sir pls check this solution not working in interviewbit
what is the intuition behind using "min" in these elements?
The idea is to check if there are occurrences of 0s in any of the past adjacent cells. Say you are currently at i = 3, j = 4 of the above example.
If you take min of past adjacent cells, and it comes out as 0 then it means that a 2×2 square matrix CANNOT be formed.
If you have min as 1 that means 3×3 matrix of 1s cannot be formed, here only a 2×2 is possible.